pcucontrol@master
[build.git] / lbuild-nightly.sh
1 #!/bin/bash
2
3 COMMANDPATH=$0
4 COMMAND=$(basename $0)
5
6 # close stdin, as with ubuntu and debian VMs this script tends to hang and wait for input ..
7 0<&-
8
9 # old guests have e.g. mount in /bin but this is no longer part of
10 # the standard PATH in recent hosts after usrmove, so let's keep it simple
11 export PATH=$PATH:/bin:/sbin
12
13 # default values, tunable with command-line options
14 DEFAULT_FCDISTRO=f31
15 DEFAULT_PLDISTRO=lxc
16 DEFAULT_PERSONALITY=linux64
17 DEFAULT_MAILDEST="build at onelab.eu"
18 DEFAULT_BUILD_SCM_URL="git://git.onelab.eu/build"
19 DEFAULT_BASE="@DATE@--@PLDISTRO@-@FCDISTRO@-@PERSONALITY@"
20
21 # default gpg path used in signing yum repo
22 DEFAULT_GPGPATH="/etc/planetlab"
23 # default email to use in gpg secring
24 DEFAULT_GPGUID="root@$( /bin/hostname )"
25
26 DEFAULT_TESTCONFIG="default"
27 # for passing args to run_log
28 RUN_LOG_EXTRAS=""
29
30 # for publishing results, and the tests settings
31 DEFAULT_WEBPATH="/build/@PLDISTRO@/"
32 DEFAULT_TESTBUILDURL="http://build.onelab.eu/"
33 # this is where the buildurl is pointing towards
34 DEFAULT_WEBROOT="/build/"
35 DEFAULT_TESTMASTER="testmaster.onelab.eu"
36
37 ####################
38 # assuming vm runs in UTC
39 DATE=$(date +'%Y.%m.%d')
40 BUILD_BEG=$(date +'%H:%M')
41 BUILD_BEG_S=$(date +'%s')
42
43 # still using /vservers for legacy reasons
44 # as far as the build & test infra, we could adopt a new name
45 # but the PL code still uses this name for now, so let's keep it simple
46 function rootdir () {
47     slice=$1; shift
48     echo /vservers/$slice
49 }
50 function logfile () {
51     slice=$1; shift
52     echo /vservers/$slice.log.txt
53 }
54
55 ########################################
56 # workaround for broken lxc-enter-namespace
57 # 1st version was relying on virsh net-dhcp-leases
58 # however this was too fragile, would not work for fedora14 containers
59 # WARNING: this code is duplicated in lbuild-initvm.sh
60 function guest_ipv4() {
61     lxc=$1; shift
62
63     mac=$(virsh -c lxc:/// domiflist $lxc | egrep 'network|bridge' | awk '{print $5;}')
64     # sanity check
65     [ -z "$mac" ] && return 0
66     arp -en | grep "$mac" | awk '{print $1;}'
67 }
68
69 # wrap a quick summary of suspicious stuff
70 # this is to focus on installation that go wrong
71 # use with care, a *lot* of other things can go bad as well
72 function summary () {
73     from=$1; shift
74     echo "******************** BEG SUMMARY"
75     python3 - $from <<EOF
76 #!/usr/bin/env python3
77 # read a full log and tries to extract the interesting stuff
78
79 import sys, re
80 m_show_line = re.compile(
81 ".* (BEG|END) (RPM|LXC).*|.*'boot'.*|\* .*| \* .*|.*is not installed.*|.*PROPFIND.*|.* (BEG|END).*:run_log.*|.* Within LXC (BEG|END) .*|.* MAIN (BEG|END).*")
82 m_installing_any = re.compile('\r  (Installing:[^\]]*]) ')
83 m_installing_err = re.compile('\r  (Installing:[^\]]*])(..+)')
84 m_installing_end = re.compile('Installed:.*')
85 m_installing_doc1 = re.compile("(.*)install-info: No such file or directory for /usr/share/info/\S+(.*)")
86 m_installing_doc2 = re.compile("(.*)grep: /usr/share/info/dir: No such file or directory(.*)")
87
88 def summary (filename):
89
90     try:
91         if filename == "-":
92             filename = "stdin"
93             f = sys.stdin
94         else:
95             f = open(filename)
96         echo = False
97         for line in f.xreadlines():
98             # first off : discard warnings related to doc
99             if m_installing_doc1.match(line):
100                 (begin,end)=m_installing_doc1.match(line).groups()
101                 line=begin+end
102             if m_installing_doc2.match(line):
103                 (begin,end)=m_installing_doc2.match(line).groups()
104                 line=begin+end
105             # unconditionnally show these lines
106             if m_show_line.match(line):
107                 print('>>>', line, end="")
108             # an 'installing' line with messages afterwards : needs to be echoed
109             elif m_installing_err.match(line):
110                 (installing,error)=m_installing_err.match(line).groups()
111                 print('>>>',installing)
112                 print('>>>',error)
113                 echo=True
114             # closing an 'installing' section
115             elif m_installing_end.match(line):
116                 echo=False
117             # any 'installing' line
118             elif m_installing_any.match(line):
119                 if echo:
120                     installing=m_installing_any.match(line).group(1)
121                     print('>>>',installing)
122                 echo=False
123             # print lines when echo is true
124             else:
125                 if echo: print('>>>',line, end="")
126         f.close()
127     except:
128         print('Failed to analyze',filename)
129
130 for arg in sys.argv[1:]:
131     summary(arg)
132 EOF
133     echo "******************** END SUMMARY"
134 }
135
136 ### we might build on a box other than the actual web server
137 # utilities for handling the pushed material (rpms, logfiles, ...)
138 function webpublish_misses_dir () {
139     ssh root@${WEBHOST}  "bash -c \"test \! -d $1\""
140 }
141 function webpublish () {
142     ssh root@${WEBHOST} "$@"
143 }
144 function webpublish_cp_stdin_to_file () {
145     ssh root@${WEBHOST} cat \> $1 \; chmod g+r,o+r $1
146 }
147 function webpublish_append_stdin_to_file () {
148     ssh root@${WEBHOST} cat \>\> $1 \; chmod g+r,o+r $1
149 }
150 # provide remote dir as first argument,
151 # so any number of local files can be passed next
152 function webpublish_rsync () {
153     local remote="$1"; shift
154     rsync --archive --delete $VERBOSE "$@" root@${WEBHOST}:"$remote"
155  }
156
157 function pretty_duration () {
158     total_seconds=$1; shift
159
160     seconds=$(($total_seconds%60))
161     total_minutes=$(($total_seconds/60))
162     minutes=$(($total_minutes%60))
163     hours=$(($total_minutes/60))
164
165     printf "%02d:%02d:%02d" $hours $minutes $seconds
166 }
167
168 # Notify recipient of failure or success, manage various stamps
169 function failure() {
170     set -x
171     # early stage ? - let's not create /build/@PLDISTRO@
172     if  [ -z "$WEBLOG" ] ; then
173         WEBHOST=localhost
174         WEBPATH=/tmp
175         WEBBASE=/tmp/lbuild-early-$(date +%Y-%m-%d)
176         WEBLOG=/tmp/lbuild-early-$(date +%Y-%m-%d).log.txt
177     fi
178     webpublish mkdir -p $WEBBASE ||:
179     webpublish_rsync $WEBLOG $LOG  ||:
180     summary $LOG | webpublish_append_stdin_to_file $WEBLOG ||:
181     (echo -n "============================== $COMMAND: failure at " ; date ; \
182         webpublish tail --lines=1000 $WEBLOG) | \
183         webpublish_cp_stdin_to_file $WEBBASE.ko ||:
184     if [ -n "$MAILDEST" ] ; then
185         ( \
186             echo "Subject: KO ${BASE} ${MAIL_SUBJECT}" ; \
187             echo "To: $MAILDEST" ; \
188             echo "see build results at        $WEBBASE_URL" ; \
189             echo "including full build log at $WEBBASE_URL/log.txt" ; \
190             echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
191             echo "........................................" ; \
192             webpublish tail --lines=1000 $WEBLOG ) | \
193             sendmail $MAILDEST
194     fi
195     exit 1
196 }
197
198 function success () {
199     set -x
200     # early stage ? - let's not create /build/@PLDISTRO@
201     if [ -z "$WEBLOG" ] ; then
202         WEBHOST=localhost
203         WEBPATH=/tmp
204         WEBLOG=/tmp/lbuild-early-$(date +%Y-%m-%d).log.txt
205     fi
206     webpublish mkdir -p $WEBBASE
207     webpublish_rsync $WEBLOG $LOG
208     summary $LOG | webpublish_append_stdin_to_file $WEBLOG
209     if [ -n "$DO_TEST" ] ; then
210         short_message="PASS"
211         ext="pass"
212         if [ -n "$IGNORED" ] ; then short_message="PASS/WARN"; ext="warn"; fi
213         ( \
214             echo "Successfully built and tested" ; \
215             echo "see build results at        $WEBBASE_URL" ; \
216             echo "including full build log at $WEBBASE_URL/log.txt" ; \
217             echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
218             [ -n "$IGNORED" ] && echo "WARNING: some tests steps failed but were ignored - see trace file" ; \
219             ) | webpublish_cp_stdin_to_file $WEBBASE.$ext
220         webpublish rm -f $WEBBASE.pkg-ok $WEBBASE.ko
221     else
222         short_message="PKGOK"
223         ( \
224             echo "Successful package-only build, no test requested" ; \
225             echo "see build results at        $WEBBASE_URL" ; \
226             echo "including full build log at $WEBBASE_URL/log.txt" ; \
227             ) | webpublish_cp_stdin_to_file $WEBBASE.pkg-ok
228         webpublish rm -f $WEBBASE.ko
229     fi
230     BUILD_END=$(date +'%H:%M')
231     BUILD_END_S=$(date +'%s')
232     if [ -n "$MAILDEST" ] ; then
233         ( \
234             echo "Subject: $short_message ${BASE} ${MAIL_SUBJECT}" ; \
235             echo "To: $MAILDEST" ; \
236             echo "$PLDISTRO ($BASE) build for $FCDISTRO completed on $(date)" ; \
237             echo "see build results at        $WEBBASE_URL" ; \
238             echo "including full build log at $WEBBASE_URL/log.txt" ; \
239             [ -n "$DO_TEST" ] && echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
240             [ -n "$IGNORED" ] && echo "WARNING: some tests steps failed but were ignored - see trace file" ; \
241             echo "BUILD TIME: begin $BUILD_BEG -- end $BUILD_END -- duration $(pretty_duration $(($BUILD_END_S-$BUILD_BEG_S)))" ; \
242             ) | sendmail $MAILDEST
243     fi
244     # XXX For some reason, we haven't been getting this email for successful builds. If this sleep
245     # doesn't fix the problem, I'll remove it -- Sapan.
246     sleep 5
247     exit 0
248 }
249
250 ##############################
251 # manage root / container contexts
252 function in_root_context () {
253     rpm -q libvirt > /dev/null
254 }
255
256 # convenient for simple commands
257 function run_in_build_guest () {
258     buildname=$1; shift
259     ssh -o StrictHostKeyChecking=no root@$(guest_ipv4 $buildname) "$@"
260 }
261
262 # run in the vm - do not manage success/failure, will be done from the root ctx
263 function build () {
264     set -x
265     set -e
266
267     echo -n "============================== Starting $COMMAND:build on "
268     date
269
270     cd /build
271     show_env
272
273     echo "Running make IN $(pwd)"
274
275     # stuff our own variable settings
276     MAKEVARS=("build-GITPATH=${BUILD_SCM_URL}" "${MAKEVARS[@]}")
277     MAKEVARS=("PLDISTRO=${PLDISTRO}" "${MAKEVARS[@]}")
278     MAKEVARS=("PLDISTROTAGS=${PLDISTROTAGS}" "${MAKEVARS[@]}")
279     MAKEVARS=("PERSONALITY=${PERSONALITY}" "${MAKEVARS[@]}")
280     MAKEVARS=("MAILDEST=${MAILDEST}" "${MAKEVARS[@]}")
281     MAKEVARS=("WEBPATH=${WEBPATH}" "${MAKEVARS[@]}")
282     MAKEVARS=("TESTBUILDURL=${TESTBUILDURL}" "${MAKEVARS[@]}")
283     MAKEVARS=("WEBROOT=${WEBROOT}" "${MAKEVARS[@]}")
284
285     MAKEVARS=("BASE=${BASE}" "${MAKEVARS[@]}")
286
287     # initialize latex
288     /build/latex-first-run.sh || :
289
290     # stage1
291     make -C /build $DRY_RUN "${MAKEVARS[@]}" stage1=true
292     # versions
293     make -C /build $DRY_RUN "${MAKEVARS[@]}" versions
294     # actual stuff
295     make -C /build $DRY_RUN "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
296
297 }
298
299 # this was formerly run in the myplc-devel chroot but now is run in the root context,
300 # this is so that the .ssh config gets done manually, and once and for all
301 function run_log () {
302     set -x
303     set -e
304     trap failure ERR INT
305
306     echo "============================== BEG $COMMAND:run_log on $(date)"
307
308     ### the URL to the RPMS/<arch> location
309     # f12 now has everything in i686; try i386 first as older fedoras have both
310     url=""
311     for a in i386 i686 x86_64; do
312         archdir=$(rootdir $BASE)/build/RPMS/$a
313         if [ -d $archdir ] ; then
314             # where was that installed
315             url=$(echo $archdir | sed -e "s,$(rootdir $BASE)/build,${WEBPATH}/${BASE},")
316             url=$(echo $url | sed -e "s,${WEBROOT},${TESTBUILDURL},")
317             break
318         fi
319     done
320
321     if [ -z "$url" ] ; then
322         echo "$COMMAND: Cannot locate arch URL for testing"
323         failure
324         exit 1
325     fi
326
327     testmaster_ssh="root@${TESTMASTER}"
328
329     # test directory name on test box
330     testdir=${BASE}
331
332     # clean it
333     ssh -n ${testmaster_ssh} rm -rf ${testdir} ${testdir}.git
334
335     # check it out in the build
336     run_in_build_guest $BASE make -C /build tests-module ${MAKEVARS[@]}
337
338     # push it onto the testmaster - just the 'system' subdir is enough
339     rsync --verbose --archive $(rootdir $BASE)/build/MODULES/tests/system/ ${testmaster_ssh}:${BASE}
340     # toss the build in the bargain, so the tests don't need to mess with extracting it
341     rsync --verbose --archive $(rootdir $BASE)/build/MODULES/build ${testmaster_ssh}:${BASE}/
342
343     # invoke test on testbox - pass url and build url - so the tests can use lbuild-initvm.sh
344     run_log_env="-p $PERSONALITY -d $PLDISTRO -f $FCDISTRO"
345
346     # temporarily turn off set -e
347     set +e
348     trap - ERR INT
349     ssh 2>&1 ${testmaster_ssh} ${testdir}/run_log --build ${BUILD_SCM_URL} --url ${url} $run_log_env $RUN_LOG_EXTRAS $VERBOSE --all; retcod=$?
350
351     set -e
352     trap failure ERR INT
353     # interpret retcod of TestMain.py; 2 means there were ignored steps that failed
354     echo "retcod from run_log" $retcod
355     case $retcod in
356         0) success=true; IGNORED="" ;;
357         2) success=true; IGNORED=true ;;
358         *) success="";   IGNORED="" ;;
359     esac
360
361     # gather logs in the build vm
362     mkdir -p $(rootdir $BASE)/build/testlogs
363     rsync --verbose --archive ${testmaster_ssh}:$BASE/logs/ $(rootdir $BASE)/build/testlogs
364     # push them to the build web
365     chmod -R a+r $(rootdir $BASE)/build/testlogs/
366     webpublish_rsync $WEBPATH/$BASE/testlogs/ $(rootdir $BASE)/build/testlogs/
367
368     echo  "============================== END $COMMAND:run_log on $(date)"
369
370     if [ -z "$success" ] ; then
371         echo "Tests have failed - bailing out"
372         failure
373     fi
374
375 }
376
377 # this part won't work if WEBHOST does not match the local host
378 # would need to be made webpublish_* compliant
379 # but do we really need this feature anyway ?
380 function sign_node_packages () {
381
382     echo "Signing node packages"
383
384     need_createrepo=""
385
386     repository=$WEBPATH/$BASE/RPMS/
387     # the rpms that need signing
388     new_rpms=
389     # and the corresponding stamps
390     new_stamps=
391
392     for package in $(find $repository/ -name '*.rpm') ; do
393         stamp=$repository/signed-stamps/$(basename $package).signed
394         # If package is newer than signature stamp
395         if [ $package -nt $stamp ] ; then
396             new_rpms="$new_rpms $package"
397             new_stamps="$new_stamps $stamp"
398         fi
399         # Or than createrepo database
400         [ $package -nt $repository/repodata/repomd.xml ] && need_createrepo=true
401     done
402
403     if [ -n "$new_rpms" ] ; then
404         # Create a stamp once the package gets signed
405         mkdir $repository/signed-stamps 2> /dev/null
406
407         # Sign RPMS. setsid detaches rpm from the terminal,
408         # allowing the (hopefully blank) GPG password to be
409         # entered from stdin instead of /dev/tty.
410         echo | setsid rpm \
411             --define "_signature gpg" \
412             --define "_gpg_path $GPGPATH" \
413             --define "_gpg_name $GPGUID" \
414             --resign $new_rpms && touch $new_stamps
415     fi
416
417      # Update repository index / yum metadata.
418     if [ -n "$need_createrepo" ] ; then
419         echo "Indexing node packages after signing"
420         if [ -f $repository/yumgroups.xml ] ; then
421             createrepo --quiet -g yumgroups.xml $repository
422         else
423             createrepo --quiet $repository
424         fi
425     fi
426 }
427
428 function show_env () {
429     set +x
430     echo FCDISTRO=$FCDISTRO
431     echo PLDISTRO=$PLDISTRO
432     echo PERSONALITY=$PERSONALITY
433     echo BASE=$BASE
434     echo BUILD_SCM_URL=$BUILD_SCM_URL
435     echo MAKEVARS="${MAKEVARS[@]}"
436     echo DRY_RUN="$DRY_RUN"
437     echo PLDISTROTAGS="$PLDISTROTAGS"
438     # this does not help, it's not yet set when we run show_env
439     #echo WEBPATH="$WEBPATH"
440     echo TESTBUILDURL="$TESTBUILDURL"
441     echo WEBHOST="$WEBHOST"
442     if in_root_context ; then
443         echo PLDISTROTAGS="$PLDISTROTAGS"
444     else
445         if [ -f /build/$PLDISTROTAGS ] ; then
446             echo "XXXXXXXXXXXXXXXXXXXX Contents of tags definition file /build/$PLDISTROTAGS"
447             cat /build/$PLDISTROTAGS
448             echo "XXXXXXXXXXXXXXXXXXXX end tags definition"
449         else
450             echo "XXXXXXXXXXXXXXXXXXXX Cannot find tags definition file /build/$PLDISTROTAGS, assuming remote pldistro"
451         fi
452     fi
453     set -x
454 }
455
456 function setupssh () {
457     base=$1; shift
458     sshkey=$1; shift
459
460     if [ -f ${sshkey} ] ; then
461         SSHDIR=$(rootdir ${base})/root/.ssh
462         mkdir -p ${SSHDIR}
463         cp $sshkey ${SSHDIR}/thekey
464         (echo "host *"; \
465             echo "  IdentityFile ~/.ssh/thekey"; \
466             echo "  StrictHostKeyChecking no" ) > ${SSHDIR}/config
467         chmod 700 ${SSHDIR}
468         chmod 400 ${SSHDIR}/*
469     else
470         echo "WARNING : could not find provided ssh key $sshkey - ignored"
471     fi
472 }
473
474 function usage () {
475     echo "Usage: $COMMAND [option] [var=value...] make-targets"
476     echo "Supported options"
477     echo " -f fcdistro - defaults to $DEFAULT_FCDISTRO"
478     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
479     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
480     echo " -m mailto - defaults to $DEFAULT_MAILDEST"
481     echo " -s build_scm_url - git URL where to fetch the build module - defaults to $DEFAULT_BUILD_SCM_URL"
482     echo "    define GIT tag or branch name appending @tagname to url"
483     echo " -t pldistrotags - defaults to \${PLDISTRO}-tags.mk"
484     echo " -b base - defaults to $DEFAULT_BASE"
485     echo "    @NAME@ replaced as appropriate"
486     echo " -o base: (overwrite) do not re-create vm, re-use base instead"
487     echo "    the -f/-d/-p/-m/-s/-t options are uneffective in this case"
488     echo " -c testconfig - defaults to $DEFAULT_TESTCONFIG"
489     echo " -y {pl,pg} - passed to run_log"
490     echo " -e step - passed to run_log"
491     echo " -i step - passed to run_log"
492     echo " -X : passes --lxc to run_log"
493     echo " -S : passes --vs to run_log"
494     echo " -x <run_log_args> - a hook to pass other arguments to run_log"
495     echo " -w webpath - defaults to $DEFAULT_WEBPATH"
496     echo " -W testbuildurl - defaults to $DEFAULT_TESTBUILDURL; this is also used to get the hostname where to publish builds"
497     echo " -r webroot - defaults to $DEFAULT_WEBROOT - the fs point where testbuildurl actually sits"
498     echo " -M testmaster - defaults to $DEFAULT_TESTMASTER"
499     echo " -Y - sign yum repo in webpath"
500     echo " -g gpg_path - to the gpg secring used to sign rpms.  Defaults to $DEFAULT_GPGPATH"
501     echo " -u gpg_uid - email used in secring. Defaults to $DEFAULT_GPGUID"
502     echo " -K sshkey - specify ssh key to use when reaching git over ssh"
503     echo " -S - do not publish source rpms"
504     echo " -B - run build only"
505     echo " -T - run test only"
506     echo " -n - dry-run: -n passed to make - vm gets created though - no mail sent"
507     echo " -v - be verbose"
508     echo " -7 - uses weekday-@FCDISTRO@ as base"
509     echo " --build-branch branch - build using the branch from build module"
510     exit 1
511 }
512
513 function main () {
514
515     set -e
516     trap failure ERR INT
517
518     # parse arguments
519     MAKEVARS=()
520     MAKETARGETS=()
521     DRY_RUN=
522     DO_BUILD=true
523     DO_TEST=true
524     PUBLISH_SRPMS=true
525     SSH_KEY=""
526     SIGNYUMREPO=""
527
528     OPTS_ORIG=$@
529     OPTS=$(getopt -o "f:d:p:m:s:t:b:o:c:y:e:i:XSx:w:W:r:M:Yg:u:K:SBTnv7i:P:h" -l "build-branch:" -- $@)
530     if [ $? != 0 ]
531     then
532         usage
533     fi
534     eval set -- "$OPTS"
535     while true; do
536         case $1 in
537             -f) FCDISTRO=$2; shift 2 ;;
538             -d) PLDISTRO=$2; shift 2 ;;
539             -p) PERSONALITY=$2; shift 2 ;;
540             -m) MAILDEST=$2; shift 2 ;;
541             -s) BUILD_SCM_URL=$2; shift 2 ;;
542             -t) PLDISTROTAGS=$2; shift 2 ;;
543             -b) BASE=$2; shift 2 ;;
544             -o) OVERBASE=$2; shift 2 ;;
545             -c) TESTCONFIG="$TESTCONFIG $2"; shift 2 ;;
546             ########## passing stuff to run_log
547             # -y foo -> run_log -y foo
548             -y) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --rspec-style $2"; shift 2 ;;
549             # -e foo -> run_log -e foo
550             -e) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --exclude $2"; shift 2 ;;
551             -i) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --ignore $2"; shift 2 ;;
552             # -X -> run_log --lxc
553             -X) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --lxc"; shift;;
554             # -S -> run_log --vs
555             -S) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --vs"; shift;;
556             # more general form to pass args to run_log
557             # -x foo -> run_log foo
558             -x) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS $2"; shift 2;;
559             ##########
560             -w) WEBPATH=$2; shift 2 ;;
561             -W) TESTBUILDURL=$2; shift 2 ;;
562             -r) WEBROOT=$2; shift 2 ;;
563             -M) TESTMASTER=$2; shift 2 ;;
564             -Y) SIGNYUMREPO=true; shift ;;
565             -g) GPGPATH=$2; shift 2 ;;
566             -u) GPGUID=$2; shift 2 ;;
567             -K) SSH_KEY=$2; shift 2 ;;
568             -S) PUBLISH_SRPMS="" ; shift ;;
569             -B) DO_TEST= ; shift ;;
570             -T) DO_BUILD= ; shift;;
571             -n) DRY_RUN="-n" ; shift ;;
572             -v) set -x ; VERBOSE="-v" ; shift ;;
573             -7) BASE="$(date +%a|tr A-Z a-z)-@FCDISTRO@" ; shift ;;
574             -P) PREINSTALLED="-P $2"; shift 2;;
575             -h) usage ; shift ;;
576             --) shift; break ;;
577         esac
578     done
579
580     # preserve options for passing them again later, together with expanded base
581     options=$OPTS_ORIG
582
583     # allow var=value stuff;
584     for target in "$@" ; do
585         # check if contains '='
586         target1=$(echo $target | sed -e s,=,,)
587         if [ "$target" = "$target1" ] ; then
588             MAKETARGETS=(${MAKETARGETS[@]} "$target")
589         else
590             MAKEVARS=(${MAKEVARS[@]} "$target")
591         fi
592     done
593
594     # set defaults
595     [ -z "$FCDISTRO" ] && FCDISTRO=$DEFAULT_FCDISTRO
596     [ -z "$PLDISTRO" ] && PLDISTRO=$DEFAULT_PLDISTRO
597     [ -z "$PERSONALITY" ] && PERSONALITY=$DEFAULT_PERSONALITY
598     [ -z "$MAILDEST" ] && MAILDEST=$(echo $DEFAULT_MAILDEST | sed -e 's, at ,@,')
599     [ -z "$PLDISTROTAGS" ] && PLDISTROTAGS="${PLDISTRO}-tags.mk"
600     [ -z "$BASE" ] && BASE="$DEFAULT_BASE"
601     [ -z "$WEBPATH" ] && WEBPATH="$DEFAULT_WEBPATH"
602     [ -z "$TESTBUILDURL" ] && TESTBUILDURL="$DEFAULT_TESTBUILDURL"
603     [ -z "$WEBROOT" ] && WEBROOT="$DEFAULT_WEBROOT"
604     [ -z "$GPGPATH" ] && GPGPATH="$DEFAULT_GPGPATH"
605     [ -z "$GPGUID" ] && GPGUID="$DEFAULT_GPGUID"
606     [ -z "$BUILD_SCM_URL" ] && BUILD_SCM_URL="$DEFAULT_BUILD_SCM_URL"
607     [ -z "$TESTCONFIG" ] && TESTCONFIG="$DEFAULT_TESTCONFIG"
608     [ -z "$TESTMASTER" ] && TESTMASTER="$DEFAULT_TESTMASTER"
609
610     [ -n "$DRY_RUN" ] && MAILDEST=""
611
612     # elaborate the extra args to be passed to run_log
613     for config in ${TESTCONFIG} ; do
614         RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --config $config"
615     done
616
617
618     if [ -n "$OVERBASE" ] ; then
619         sedargs="-e s,@DATE@,${DATE},g"
620         BASE=$(echo ${OVERBASE} | sed $sedargs)
621     else
622         sedargs="-e s,@DATE@,${DATE},g -e s,@FCDISTRO@,${FCDISTRO},g -e s,@PLDISTRO@,${PLDISTRO},g -e s,@PERSONALITY@,${PERSONALITY},g"
623         BASE=$(echo ${BASE} | sed $sedargs)
624     fi
625
626     ### elaborate mail subject
627     if [ -n "$DO_BUILD" -a -n "$DO_TEST" ] ; then
628         MAIL_SUBJECT="full"
629     elif [ -n "$DO_BUILD" ] ; then
630         MAIL_SUBJECT="pkg-only"
631     elif [ -n "$DO_TEST" ] ; then
632         MAIL_SUBJECT="test-only"
633     fi
634     if [ -n "$OVERBASE" ] ; then
635         MAIL_SUBJECT="${MAIL_SUBJECT} rerun"
636     else
637         MAIL_SUBJECT="${MAIL_SUBJECT} fresh"
638     fi
639     short_hostname=$(hostname | cut -d. -f1)
640     MAIL_SUBJECT="on ${short_hostname} - ${MAIL_SUBJECT}"
641
642     ### compute WEBHOST from TESTBUILDURL
643     # this is to avoid having to change the builds configs everywhere
644     # simplistic way to extract hostname from a URL
645     WEBHOST=$(echo "$TESTBUILDURL" | cut -d/ -f 3)
646
647     if ! in_root_context ; then
648         # in the vm
649         echo "==================== Within LXC BEG $(date)"
650         build
651         echo "==================== Within LXC END $(date)"
652
653     else
654         trap failure ERR INT
655         # we run in the root context :
656         # (*) create or check for the vm to use
657         # (*) copy this command in the vm
658         # (*) invoke it
659
660         if [ -n "$OVERBASE" ] ; then
661             ### Re-use a vm (finish an unfinished build..)
662             if [ ! -d $(rootdir ${BASE}) ] ; then
663                 echo $COMMAND : cannot find vm $BASE
664                 exit 1
665             fi
666             # manage LOG - beware it might be a symlink so nuke it first
667             LOG=$(logfile ${BASE})
668             rm -f $LOG
669             exec > $LOG 2>&1
670             set -x
671             echo "XXXXXXXXXX $COMMAND: using existing vm $BASE" $(date)
672             # start in case e.g. we just rebooted
673             virsh -c lxc:/// start ${BASE} || :
674             # retrieve environment from the previous run
675             FCDISTRO=$(run_in_build_guest $BASE /build/getdistroname.sh)
676             BUILD_SCM_URL=$(run_in_build_guest $BASE make --no-print-directory -C /build stage1=skip +build-GITPATH)
677             # for efficiency, crop everything in one make run
678             tmp=/tmp/${BASE}-env.sh
679             run_in_build_guest $BASE make --no-print-directory -C /build stage1=skip \
680                 ++PLDISTRO ++PLDISTROTAGS ++PERSONALITY ++MAILDEST ++WEBPATH ++TESTBUILDURL ++WEBROOT > $tmp
681             . $tmp
682             rm -f $tmp
683             # update build
684             [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
685             run_in_build_guest $BASE "(cd /build; git pull; make tests-clean)"
686             # make sure we refresh the tests place in case it has changed
687             rm -f /build/MODULES/tests
688             options=(${options[@]} -d $PLDISTRO -t $PLDISTROTAGS -s $BUILD_SCM_URL)
689             [ -n "$PERSONALITY" ] && options=(${options[@]} -p $PERSONALITY)
690             [ -n "$MAILDEST" ] && options=(${options[@]} -m $MAILDEST)
691             [ -n "$WEBPATH" ] && options=(${options[@]} -w $WEBPATH)
692             [ -n "$TESTBUILDURL" ] && options=(${options[@]} -W $TESTBUILDURL)
693             [ -n "$WEBROOT" ] && options=(${options[@]} -r $WEBROOT)
694             show_env
695         else
696             # create vm: check it does not exist yet
697             i=
698             while [ -d $(rootdir ${BASE})${i} ] ; do
699                 # we name subsequent builds <base>-n<i> so the logs and builds get sorted properly
700                 [ -z ${i} ] && BASE=${BASE}-n
701                 i=$((${i}+1))
702                 if [ $i -gt 100 ] ; then
703                     echo "$COMMAND: Failed to create build vm $(rootdir ${BASE})${i}"
704                     exit 1
705                 fi
706             done
707             BASE=${BASE}${i}
708             # need update
709             # manage LOG - beware it might be a symlink so nuke it first
710             LOG=$(logfile ${BASE})
711             rm -f $LOG
712             exec > $LOG 2>&1
713             set -x
714             echo "XXXXXXXXXX $COMMAND: creating vm $BASE" $(date)
715             show_env
716
717             ### extract the whole build - much simpler
718             tmpdir=/tmp/$COMMAND-$$
719             GIT_REPO=$(echo $BUILD_SCM_URL | cut -d@ -f1)
720             GIT_TAG=$(echo $BUILD_SCM_URL | cut -s -d@ -f2)
721             GIT_TAG=${GIT_TAG:-master}
722             mkdir -p $tmpdir
723             ( git archive --remote=$GIT_REPO $GIT_TAG | tar -C $tmpdir -xf -) || \
724                 ( echo "==================== git archive FAILED, trying git clone instead" ; \
725                   git clone $GIT_REPO $tmpdir && cd $tmpdir && git checkout $GIT_TAG && rm -rf .git)
726
727             # Create lxc vm
728             cd $tmpdir
729             ./lbuild-initvm.sh $VERBOSE -f ${FCDISTRO} -d ${PLDISTRO} -p ${PERSONALITY} ${PREINSTALLED} ${BASE}
730             # cleanup
731             cd -
732             rm -rf $tmpdir
733             # Extract build again - in the vm
734             [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
735             run_in_build_guest $BASE "(git clone $GIT_REPO /build; cd /build; git checkout $GIT_TAG)"
736         fi
737         echo "XXXXXXXXXX $COMMAND: preparation of vm $BASE done" $(date)
738
739         # The log inside the vm contains everything
740         LOG2=$(rootdir ${BASE})/log.txt
741         (echo "==================== BEG LXC Transcript of vm creation" ; \
742          cat $LOG ; \
743          echo "==================== END LXC Transcript of vm creation" ; \
744          echo "xxxxxxxxxx Messing with logs, symlinking $LOG2 to $LOG" ) >> $LOG2
745         ### not too nice : nuke the former log, symlink it to the new one
746         rm $LOG; ln -s $LOG2 $LOG
747         LOG=$LOG2
748         # redirect log again
749         exec >> $LOG 2>&1
750
751         sedargs="-e s,@DATE@,${DATE},g -e s,@FCDISTRO@,${FCDISTRO},g -e s,@PLDISTRO@,${PLDISTRO},g -e s,@PERSONALITY@,${PERSONALITY},g"
752         WEBPATH=$(echo ${WEBPATH} | sed $sedargs)
753         webpublish mkdir -p ${WEBPATH}
754
755         # where to store the log for web access
756         WEBBASE=${WEBPATH}/${BASE}
757         WEBLOG=${WEBPATH}/${BASE}/log.txt
758         # compute the log URL - inserted in the mail messages for convenience
759         WEBBASE_URL=$(echo $WEBBASE | sed -e "s,//,/,g" -e "s,${WEBROOT},${TESTBUILDURL},")
760
761         if [ -n "$DO_BUILD" ] ; then
762
763             # invoke this command into the build directory of the vm
764             cp $COMMANDPATH $(rootdir ${BASE})/build/
765
766             # invoke this command in the vm for building (-T)
767             run_in_build_guest $BASE chmod +x /build/$COMMAND
768             run_in_build_guest $BASE /build/$COMMAND "${options[@]}" -b "${BASE}" "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
769         fi
770
771         # publish to the web so run_log can find them
772         set +e
773         trap - ERR INT
774 #        webpublish rm -rf $WEBPATH/$BASE
775         # guess if we've been doing any debian-related build
776         if [ ! -f $(rootdir $BASE)/etc/debian_version  ] ; then
777             webpublish mkdir -p $WEBPATH/$BASE/{RPMS,SRPMS}
778             # after moving to f29, we see this dir created as 700
779             # as remote umask is 077
780             webpublish chmod 755 $WEBPATH/$BASE
781             webpublish_rsync $WEBPATH/$BASE/RPMS/ $(rootdir $BASE)/build/RPMS/
782             [[ -n "$PUBLISH_SRPMS" ]] && webpublish_rsync $WEBPATH/$BASE/SRPMS/ $(rootdir $BASE)/build/SRPMS/
783         else
784             # run scanpackages so we can use apt-get on this
785             # (not needed on fedora b/c this is done by the regular build already)
786             run_in_build_guest $BASE "(cd /build ; dpkg-scanpackages DEBIAN/ | gzip -9c > Packages.gz)"
787             webpublish mkdir -p $WEBPATH/$BASE/DEBIAN
788             webpublish_rsync $WEBPATH/$BASE/DEBIAN/ $(rootdir $BASE)/build/DEBIAN/*.deb
789             webpublish_rsync $WEBPATH/$BASE/ $(rootdir $BASE)/build/Packages.gz
790         fi
791         # publish myplc-release if this exists
792         release=$(rootdir $BASE)/build/myplc-release
793         [ -f $release ] && webpublish_rsync $WEBPATH/$BASE $release
794         set -e
795         trap failure ERR INT
796
797         # create yum repo and sign packages.
798         if [ -n "$SIGNYUMREPO" ] ; then
799             # this script does not yet support signing on a remote (webhost) repo
800             sign_here=$(hostname) ; sign_web=$(webpublish hostname)
801             if [ "$hostname" = "$sign_here" ] ; then
802                 sign_node_packages
803             else
804                 echo "$COMMAND does not support signing on a remote yum repo"
805                 echo "you might want to turn off the -y option, or run this on the web server box itself"
806                 exit 1
807             fi
808         fi
809
810         if [ -n "$DO_TEST" ] ; then
811             run_log
812         fi
813
814         success
815
816         echo "==================== MAIN END $(date)"
817     fi
818
819 }
820
821 ##########
822 main "$@"